---
title: textLength
slug: Web/SVG/Attribute/textLength
tags:
  - Attribute
  - CSS
  - HTML
  - Javascrip
  - SVG Attribute
  - Text
  - height
  - length
  - size
  - width
---
<div>{{SVGRef}}</div>

<p>The <strong><code>textLength</code></strong> attribute, available on SVG {{SVGElement("text")}} and {{SVGElement("tspan")}} elements, lets you specify the width of the space into which the text will draw. The {{glossary("user agent")}} will ensure that the text does not extend farther than that distance, using the method or methods specified by the {{SVGAttr("lengthAdjust")}} attribute. By default, only the spacing between characters is adjusted, but the glyph size can also be adjusted if you change <code>lengthAdjust</code>.</p>

<p>By using <code>textLength</code>, you can ensure that your SVG text displays at the same width regardless of conditions including web fonts failing to load (or not having loaded yet).</p>

<p>Four elements are using this attribute: {{SVGElement("text")}}, {{SVGElement("textPath")}}, {{SVGElement("tref")}}, and {{SVGElement("tspan")}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css">html, body, svg {
  height: 100%;
}</pre>
</div>

<pre class="brush: html">&lt;svg viewBox="0 0 200 60" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;text y="20" textLength="6em"&gt;Small text length&lt;/text&gt;
  &lt;text y="40" textLength="120%"&gt;Big text length&lt;/text&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample("topExample", "200", "100")}}</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td>{{cssxref("length-percentage")}} | {{cssxref("number")}}</td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td>None</td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>&lt;length-percentage&gt;</code></dt>
 <dd>This value specifies the width of the space the text will be adjusted to occupy as absolute length or percentage.</dd>
 <dt><code>&lt;number&gt;</code></dt>
 <dd>A numeric value outlines a length referring to the units of the current coordinate system.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>Let's create a simple example that presents text you can resize using an {{HTMLElement("input")}} element of type <code><a href="/en-US/docs/Web/HTML/Element/input/range">"range"</a></code>.</p>

<div class="hidden">
<h3 id="CSS">CSS</h3>

<pre class="brush: css">.controls {
  font: 16px "Open Sans", "Arial", sans-serif;
}</pre>
</div>

<h3 id="SVG">SVG</h3>

<p>Let's start with the SVG. It's pretty basic, with a 1000-by-300 pixel space mapped into a 10 centimeter by 3 centimeter box.</p>

<pre class="brush: html">&lt;svg width="10cm" height="3cm" viewBox="0 0 1000 300"
    xmlns="http://www.w3.org/2000/svg"&gt;

  &lt;rect x="1" y="1" width="998" height="298"
      fill="none" stroke="green" stroke-width="2"/&gt;

  &lt;text id="hello" x="10" y="150"
      font-family="sans-serif" font-size="60" fill="green"&gt;
    Hello world!
  &lt;/text&gt;
&lt;/svg&gt;</pre>

<p>First, a {{SVGElement("rect")}} element is used to create and stroke a rectangle to contain the text. Then {{SVGElement("text")}} is used to create the text element itself, with an {{SVGAttr("id")}} of <code>"hello"</code>.</p>

<h3 id="HTML">HTML</h3>

<p>The HTML is also simple, with only two displayed elements contained inside a grouping {{HTMLElement("div")}}:</p>

<pre class="brush: html">&lt;div class="controls"&gt;
  &lt;input type="range" id="widthSlider" min="80" max="978"&gt;
  &lt;span id="widthDisplay"&gt;&lt;/span&gt;
&lt;/div&gt;</pre>

<p>The {{HTMLElement("input")}} element, of type <code>"range"</code>, is used to create the slider control the user will manipulate to change the width of the text. A {{HTMLElement("span")}} element of ID <code>"widthDisplay"</code> is provided to display the current width value.</p>

<h3 id="JavaScript">JavaScript</h3>

<p>Finally, let's have a look at the JavaScript code. It starts by stashing references to the elements it will need to access, using {{domxref("Document.getElementById()")}}:</p>

<pre class="brush: js">const widthSlider = document.getElementById("widthSlider");
const widthDisplay = document.getElementById("widthDisplay");
const textElement = document.getElementById("hello");
const baseLength = Math.floor(textElement.textLength.baseVal.value);

widthSlider.value = baseLength;

widthSlider.addEventListener("input", function(event) {
  textElement.textLength.baseVal.newValueSpecifiedUnits(
      SVGLength.SVG_LENGTHTYPE_PX, widthSlider.valueAsNumber);
  widthDisplay.innerText = widthSlider.value;
}, false);

widthSlider.dispatchEvent(new Event("input"));

</pre>

<p>After fetching the element references, an {{domxref("EventListener")}} is established by calling {{domxref("EventTarget.addEventListener", "addEventListener()")}} on the slider control, to receive any {{event("input")}} events which occur. These events will be sent any time the slider's value changes, even if the user hasn't stopped moving it, so we can responsively adjust the text width.</p>

<p>When an <code>"input"</code> event occurs, we call {{domxref("SVGLength.newValueSpecifiedUnits()")}} to set the value of <code>textLength</code> to the slider's new value, using the <code>SVGLength</code> interface's <code>SVG_LENGTHTYPE_PX</code> unit type to indicate that the value represents pixels. Note that we have to dive into <code>textLength</code> to get its <code>baseVal</code> property; <code>textLength</code> is stored as an {{domxref("SVGLength")}} object, so we can't treat it like a plain number.</p>

<p>After updating the text width, the contents of the <code>widthDisplay</code> box are updated with the new value as well, and we're finished.</p>

<h3 id="Result">Result</h3>

<p>Here's what the example looks like. Try dragging the slider around to get a feel for what it does.</p>

<p>{{EmbedLiveSample("Example", 650, 160)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "text.html#TextElementTextLengthAttribute", "textLength")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Allowed percentages and numbers as values.</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "text.html#TextElementTextLengthAttribute", "textLength")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("svg.attributes.textLength")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>SVG Tutorial: <a href="/en-US/docs/Web/SVG/Tutorial/Texts">Texts</a></li>
 <li>{{domxref("SVGAnimatedLength")}} and {{domxref("SVGLength")}}</li>
 <li>{{SVGElement("text")}}</li>
</ul>
